<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: ALM_RequerimientoDetalleLog.xml */
/* Generado: 2021-11-05 04:08:06 */

/* Mantenimiento de los registros de la tabla ALM_RequerimientoDetalleLog */
abstract class BaseALM_RequerimientoDetalleLogDP extends ALM_RequerimientoDetalleLogBV
{
    /* Constructor ( Establece los valores desde un objeto ALM_RequerimientoDetalleLogBN ) */
    public function __construct( ALM_RequerimientoDetalleLogBN $o_ALM_RequerimientoDetalleLogBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN ) )
        {
            $this->setByBN( $o_ALM_RequerimientoDetalleLogBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto ALM_RequerimientoDetalleLogBN */
    public function setByBN( ALM_RequerimientoDetalleLogBN $o_ALM_RequerimientoDetalleLogBN )
    {
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getIdRequerimientoLog() ) )
        {
            $this->setIdRequerimientoLog( $o_ALM_RequerimientoDetalleLogBN->getIdRequerimientoLog() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getTipo() ) )
        {
            $this->setTipo( $o_ALM_RequerimientoDetalleLogBN->getTipo() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getIdRequerimiento() ) )
        {
            $this->setIdRequerimiento( $o_ALM_RequerimientoDetalleLogBN->getIdRequerimiento() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getIdRequerimientoDetalle() ) )
        {
            $this->setIdRequerimientoDetalle( $o_ALM_RequerimientoDetalleLogBN->getIdRequerimientoDetalle() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_ALM_RequerimientoDetalleLogBN->getIdCompania() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_ALM_RequerimientoDetalleLogBN->getIdSucursal() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getIdMoneda() ) )
        {
            $this->setIdMoneda( $o_ALM_RequerimientoDetalleLogBN->getIdMoneda() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getIdPersona() ) )
        {
            $this->setIdPersona( $o_ALM_RequerimientoDetalleLogBN->getIdPersona() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getIdItem() ) )
        {
            $this->setIdItem( $o_ALM_RequerimientoDetalleLogBN->getIdItem() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getCantidad() ) )
        {
            $this->setCantidad( $o_ALM_RequerimientoDetalleLogBN->getCantidad() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitario() ) )
        {
            $this->setPrecioUnitario( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitario() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitarioMN() ) )
        {
            $this->setPrecioUnitarioMN( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitarioMN() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitarioME() ) )
        {
            $this->setPrecioUnitarioME( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitarioME() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitarioIGV() ) )
        {
            $this->setPrecioUnitarioIGV( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitarioIGV() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitarioIGVMN() ) )
        {
            $this->setPrecioUnitarioIGVMN( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitarioIGVMN() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitarioIGVME() ) )
        {
            $this->setPrecioUnitarioIGVME( $o_ALM_RequerimientoDetalleLogBN->getPrecioUnitarioIGVME() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getTipoCambio() ) )
        {
            $this->setTipoCambio( $o_ALM_RequerimientoDetalleLogBN->getTipoCambio() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_ALM_RequerimientoDetalleLogBN->getFechaCreacion() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_ALM_RequerimientoDetalleLogBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_ALM_RequerimientoDetalleLogBN->getFechaModificacion() );
        }
        if ( !is_null( $o_ALM_RequerimientoDetalleLogBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_ALM_RequerimientoDetalleLogBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_ALM_RequerimientoDetalleLogFN = new ALM_RequerimientoDetalleLogFN();
        $o_ALM_RequerimientoDetalleLogBN = $o_ALM_RequerimientoDetalleLogFN->selectByPk( $this->getIdRequerimientoLog() );
        if ( is_null( $o_ALM_RequerimientoDetalleLogBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO ALM_RequerimientoDetalleLog ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdRequerimientoLog() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRequerimientoLog";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdRequerimientoLog()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Tipo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRequerimiento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."idRequerimiento";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdRequerimiento()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRequerimientoDetalle() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRequerimientoDetalle";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdRequerimientoDetalle()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdMoneda() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdMoneda";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdMoneda()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPersona";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Cantidad";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitario() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitario";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitario()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioMN() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioMN";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioMN()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioME() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioME";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioME()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioIGV() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioIGV";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioIGV()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioIGVMN() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioIGVMN";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioIGVMN()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioIGVME() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioIGVME";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioIGVME()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoCambio() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoCambio";
                $s_SQLQuery2 .= $s_Separator."".$this->getTipoCambio()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE ALM_RequerimientoDetalleLog SET ";
            $s_Separator = "";
            if ( !is_null( $this->getTipo() ) )
            {
                $s_SQLQuery .= $s_Separator."Tipo = '".$this->getTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRequerimiento() ) )
            {
                $s_SQLQuery .= $s_Separator."idRequerimiento = ".$this->getIdRequerimiento()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRequerimientoDetalle() ) )
            {
                $s_SQLQuery .= $s_Separator."IdRequerimientoDetalle = ".$this->getIdRequerimientoDetalle()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdMoneda() ) )
            {
                $s_SQLQuery .= $s_Separator."IdMoneda = '".$this->getIdMoneda()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery .= $s_Separator."IdPersona = ".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidad() ) )
            {
                $s_SQLQuery .= $s_Separator."Cantidad = ".$this->getCantidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitario() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitario = ".$this->getPrecioUnitario()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioMN() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioMN = ".$this->getPrecioUnitarioMN()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioME() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioME = ".$this->getPrecioUnitarioME()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioIGV() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioIGV = ".$this->getPrecioUnitarioIGV()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioIGVMN() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioIGVMN = ".$this->getPrecioUnitarioIGVMN()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioIGVME() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioIGVME = ".$this->getPrecioUnitarioIGVME()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoCambio() ) )
            {
                $s_SQLQuery .= $s_Separator."TipoCambio = ".$this->getTipoCambio()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdRequerimientoLog = ".$this->getIdRequerimientoLog().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM ALM_RequerimientoDetalleLog WHERE  IdRequerimientoLog = ".$this->getIdRequerimientoLog().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>